︠3f478d6f-29b5-4f53-839b-9b1dd97bf81fi︠
%html
Load sympy's GA Module

︡cf400f52-6c08-4ea7-82f0-7bcc08622012︡{"html": "Load sympy's GA Module"}︡
︠45e596a7-07fd-4f8d-a643-ea159bbc0826︠
from sympy.galgebra.GA import *
︡6be30c14-7d98-4fac-9997-e5b7310133fb︡︡
︠acc05c36-37a1-49bc-b191-c75743ac0a32i︠
%html
The documentation at http://docs.sympy.org/modules/galgebra/GA/GAsympy.html says you need to do this to get access to GA variables for operations.

︡25e5820c-a0db-4261-935f-a3bf64758927︡{"html": "The documentation at http://docs.sympy.org/modules/galgebra/GA/GAsympy.html says you need to do this to get access to GA variables for operations."}︡
︠4462518e-2559-473d-87cf-9fc0a8a7fa57︠
set_main(sys.modules[__name__]);dir(sympy.galgebra.GA)
︡986fdc6c-21cb-449b-afcb-f0be99470321︡{"stdout": "['HALF', 'LaTeX_lst', 'MAIN_PROGRAM', 'MV', 'NUMPAT', 'ONE', 'TWO', 'TrigSimp', 'ZERO', '__builtins__', '__doc__', '__file__', '__name__', '__package__', 'abs_type', 'add_type', 'build_base', 'collect', 'collect_common_factors', 'comb', 'copy', 'cp', 'diagpq', 'dualsort', 'expand', 'function_lst', 'is_quasi_unit_numpy_array', 'isint', 'israt', 'magnitude', 'make_null_array', 'make_scalars', 'make_symbols', 'mul_type', 'normalize', 'numeric', 'numpy', 'os', 'plist', 'pow_type', 'print_lst', 'reciprocal_frame', 'reduce_base', 'regrep', 'set_main', 'set_names', 'sqrfree', 'sqrt', 'string', 'sub_base', 'sym_type', 'symbol', 'sympy', 'sys', 'test_int_flgs', 'types', 'unabs', 'vector_fct']"}︡
︠1fd228f2-5f41-4bae-a4b5-28032da8753e︠
MV.setup('a b c d e')
︡84bc4410-0495-4449-9243-c509a6bb04be︡{"stdout": "'Setup of a b c d e complete!'"}︡
︠e5be95d9-3050-4d20-9e7e-1bf2f615badb︠
type(a)
︡d3b30049-f504-4bfd-8aed-e08c36c0e92c︡{"stdout": "<class 'sympy.galgebra.GA.MV'>"}︡
︠a8c884cc-b662-4020-99c0-25f58afa83a6︠
MV.set_str_format(1)
︡d5b46f0c-2df8-438d-9240-344671fea738︡︡
︠76361afa-45b8-4bf5-986c-e4c1524fae57︠
print 'e|(a^b^c) =',e|(a^b^c)
︡ae556693-51c3-4aac-bf61-1a7a8623b6e5︡{"stdout": "e|(a^b^c) = ((c.e))a^b\n+(-(b.e))a^c\n+((a.e))b^c"}︡
︠19901b8e-2d22-466f-82b3-ecf33801fd2a︠
print 'a*(b^c)-b*(a^c)+c*(a^b) =',a*(b^c)-b*(a^c)+c*(a^b)
︡0d382be0-c49f-44fc-af44-262729f4cd17︡{"stdout": "a*(b^c)-b*(a^c)+c*(a^b) = (3)a^b^c"}︡
︠9f4345c9-3581-40ff-824c-bb53447cdbaf︠
e=a*(b^c)-b*(a^c)+c*(a^b)
︡fe4f45d4-b5a6-49c6-818a-a644ba400092︡︡
︠70320bd4-09aa-47bf-9435-64e9683e5969︠
e
︡f24b619e-cc9a-466d-999e-b35488ea91e2︡{"stdout": "<sympy.galgebra.GA.MV object at 0x5cdea90>"}︡
︠59914e42-3ee9-4d97-b09c-f66b7158d5e0︠
print e
︡387fb099-3e52-4db5-8dfd-252a33537517︡{"stdout": "(3)a^b^c"}︡
︠c5577af5-bdb2-4fdb-b6c4-5b1e2630727e︠
dir(e)
︡4294b3b5-df99-4b81-8898-df05c3246355︡{"stdout": "['I', 'Name', '__add__', '__add_ab__', '__call__', '__class__', '__delattr__', '__dict__', '__div__', '__div_ab__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__mul__', '__neg__', '__new__', '__or__', '__pos__', '__pow__', '__radd__', '__reduce__', '__reduce_ex__', '__repr__', '__rmul__', '__ror__', '__rsub__', '__rxor__', '__setattr__', '__sizeof__', '__str__', '__sub__', '__sub_ab__', '__subclasshook__', '__weakref__', '__xor__', 'add_in_place', 'addition', 'basis', 'basis_map', 'basislabel', 'basislabel_lst', 'basisroot', 'blade_table', 'bladeflg', 'bladelabel', 'bladeprint', 'btable', 'bvec', 'cancel', 'collect', 'combine_common_factors', 'compact', 'construct_index', 'contract', 'convert', 'convert_from_blades', 'convert_to_blades', 'coord', 'coords', 'copy', 'cse', 'curvilinear_flg', 'ddt', 'debug', 'define_basis', 'define_metric', 'define_reciprocal_frame', 'diff', 'div', 'even', 'expand', 'flatten', 'g', 'gabasis', 'geometric_product', 'grad', 'grad_ext', 'grad_int', 'ibtable', 'index', 'inner_product', 'inverse_blade_table', 'is_pure', 'is_setup', 'mag2', 'max_grade', 'metric', 'metric_str', 'mtable', 'multiplication_table', 'mv', 'n', 'n1', 'n1rg', 'name', 'named', 'nbasis', 'npow', 'nrg', 'odd', 'outer_product', 'pad_zeros', 'print_bases', 'print_blades', 'printmv', 'printnm', 'project', 'puregrade', 'rebase', 'reduce_basis', 'reduce_basis_loop', 'rev', 'scalar_fct', 'scalar_mul', 'scalar_mul_inplace', 'scalar_to_symbol', 'set_coef', 'set_coords', 'set_name', 'set_str_format', 'set_value', 'setup', 'simplify', 'sqrfree', 'str_mode', 'str_rep', 'sub_in_place', 'sub_mv', 'sub_scalar', 'subs', 'substitute_base', 'subtraction', 'tables_flg', 'trigsimp', 'trim', 'vbasis', 'vdiff', 'vector_fct', 'vsyms', 'wedge', 'x']"}︡
︠ab06b88f-6edf-4f6e-90de-eaf90e1c923c︠
x=a+b
︡6bf1cb5d-639e-4fdb-b8ea-564d93a2176e︡︡
︠cadfd025-20f2-4e76-a672-9a75a1b0ab74︠
print(x)
︡8d67bfc3-a0f1-460a-96ee-12440f85edbb︡{"stdout": "a\n+b"}︡
︠38558797-1e65-4ef6-88be-fb7432f68260i︠
%html
The "|" is used for inner product.  In the output, it seems to be displayed as ((a.b))1 perhaps to show that it is a 1-vector.

︡5c0cea72-1c2d-4e8f-b534-9a007a47e67b︡{"html": "The \"|\" is used for inner product.  In the output, it seems to be displayed as ((a.b))1 perhaps to show that it is a 1-vector."}︡
︠3df3acba-55a7-475b-a51c-bac9dd4973ed︠
y=a|b
︡a1e865c3-a8c6-4c77-8e9b-0669d206b580︡︡
︠ee8a204b-6ead-47c3-86d5-8985dbf5df5b︠
print y
︡9c0fd14e-0937-4fa8-93a7-54f5c0c86e66︡{"stdout": "((a.b))1"}︡
︠db7872a6-32e0-4078-bccc-cbccbc489f2ei︠
%html
The wedge (or outer) product producing a bivector.

︡0cda05b9-8516-4421-b682-cfd71d3cc102︡{"html": "The wedge (or outer) product producing a bivector."}︡
︠2056fbd7-199d-437e-bad7-d67f62e6e48a︠
w=a^b
︡77150331-1b76-4974-a034-9a59763e22d6︡︡
︠f8fc2fc2-63dd-46ba-9eee-ffcbb3fcfe0b︠
print w
︡c30e5e17-2504-40ee-a02b-ed3618817277︡{"stdout": "a^b"}︡
︠e7982d4c-05ba-4dd6-a52f-a709ba6c023fi︠
%html
The geometric product of a and b works as expected!

︡e3dd5094-9fe8-482a-819c-60af4af46967︡{"html": "The geometric product of a and b works as expected!"}︡
︠57a0b0dd-0234-4a9e-a33f-7935ad327ec6︠
v=a*b
︡61955413-2fc7-4175-a22b-01a8355e3712︡︡
︠33aaecda-9c2f-4cf8-85a1-49fb7b33ce07︠
print v
︡767cfb57-6386-485b-8e8c-421fddcbd07b︡{"stdout": "((a.b))1\n+a^b"}︡
︠e00fc74d-0a27-492a-8e55-301893c3a8a3︠
c=(a+b)*(a+b)
︡051b43f7-d0c9-4342-a515-10a93cbd3c38︡︡
︠65dd326e-0c87-4629-bd98-9e9fa4254617︠
print c
︡beb443c0-0e50-4238-bfe2-93d31ca51f0c︡{"stdout": "((a**2) + (b**2) + 2*(a.b))1"}︡
︠0fae07a9-1825-4ef2-9ad9-a7c00d1fea00︠
print c**2
︡05a1ed54-a97c-4479-aa62-5a6d9e157f0e︡{"stdout": "(2*(a**2) + 2*(b**2) + 4*(a.b))1"}︡
